function vypocetvaleccz;
global scrsz a r x

Am(1)=0;
handle=findobj('Tag','a');
a=str2num(get(handle,'String'));
handle=findobj('Tag','r');
r=str2num(get(handle,'String'));
x=round(10*(a-0.1));%stanoveni max poctu souctu pro Ezsek
if x>90 
   x=90; 
end
p=0;
close
A0=-besselj(0,2*pi*a)/besselh(0,2,2*pi*a);
%okno s procenty HOTOVO
h0 = figure('Color',[0.8 0.8 0.8], ...
	'FileName','..\vypocet.m', ...
	'MenuBar','none', ...
	'Name','Difrakce na vlci 1.0', ...
	'NumberTitle','off', ...
    'Position',[scrsz(3)/2-150 scrsz(4)/2-40 300 80], ...
	'PaperPosition',[18 180 576 480], ...
	'PaperUnits','points', ...
	'Resize','off', ...
	'Tag','zobraz', ...
	'ToolBar','none');
h1 = uicontrol('Parent',h0, ...
	'Units','points', ...
    'BackgroundColor',[0.8 0.8 0.8], ...
    'Callback','', ...
	'ListboxTop',0, ...
	'Position',[50 20 115 15], ...
	'String',['ekejte prosm...' num2str(p) ' % hotovo.'], ...
    'Style','text', ...
	'Tag','Procenta');

figure(h0)
   %Vlastni vypocet
for theta=1:181
    Ezprim(theta)=cos(2*pi*r*cos((theta-1)*pi/180))+j*sin(2*pi*r*cos((theta-1)*pi/180));%intenzita primarni vlny
    Ezsekk=A0*besselh(0,2,2*pi*r)*cos(0); 											%pocatecni nastaveni pro soucet 
   																							%Am*Hm*cos(m*theta) m=0
    for m=1:60+x																				
        Am(theta)=-2*j^m*besselj(m,2*pi*a)/besselh(m,2,2*pi*a);
        Ezsek(theta)=Ezsekk+Am(theta)*besselh(m,2,2*pi*r)*cos(m*(theta-1)*pi/180);%intenzita sekundarni vlny
        Ezsekk=Ezsek(theta);   
    end
    Ezvysl(theta)=Ezsek(theta)+Ezprim(theta);										%intenzita vysledne vlny
	uheltheta(theta)=theta-1;
    if (p ~= round(theta/18)*10)																%pocitadlo procent
        p = round(theta/18)*10;
        set(findobj('Tag','Procenta'),'String',['ekejte prosm...' num2str(p) ' % hotovo.']);
        pause(0.000001);
    end
end

close all;
%objekt zobrazeni grafu s vysledky
h0 = figure('Color',[0.8 0.8 0.8], ...
	'FileName','fresdif.m', ...
	'MenuBar','none', ...
	'Name','Difrakce na vlci 1.0', ...
	'NumberTitle','off', ...
	'PaperUnits','points', ...
	'Position',[scrsz(3)/2-500 scrsz(4)/2-300 1000 600], ...
	'Tag','grafy', ...
	'ToolBar','none');
wsize = get(findobj('Tag','grafy'),'Position'); %velikost tohoto okna s grafy 
										    					%pro dalsi umistovani objektu
                                                 
%objekt text Ezsek=                                                 
h1 = uicontrol('Parent',h0, ...
   'BackgroundColor',[0.8 0.8 0.8], ...
   'Callback','', ...
	'ListboxTop',0, ...
	'Position',[230 550 200 15], ...
	'String','', ...
	'HorizontalAlignment','left', ...
    'Style','text', ...
	'Tag','sekundarni');
%objekt text Ezvysl=                                                 
h1 = uicontrol('Parent',h0, ...
    'BackgroundColor',[0.8 0.8 0.8], ...
    'Callback','', ...
	'ListboxTop',0, ...
    'Position',[675 550 200 15],...
	'String','', ...
	'HorizontalAlignment','left', ...
    'Style','text', ...
	'Tag','vysledna');
%objekt text r/lambda= a a/lambda=                                                 
h1 = uicontrol('Parent',h0, ...
    'BackgroundColor',[0.8 0.8 0.8], ...
    'Callback','', ...
	'HorizontalAlignment','left', ...
	'ListboxTop',0, ...
	'Position',[20 550 80 30], ...
	'String','', ...
    'Style','text', ...
	'Tag','vypis r a');
%vlastni aktivovani okna, grafu a textu
figure(h0);
subplot(1,2,1);
polar(uheltheta*pi/180,abs(Ezsek(uheltheta+1)),'r');
set(gca,'Xlabel',text('String','Ez sekundrn',...
   'HorizontalAlignment','center',...
   'VerticalAlignment','Top'))
set(gca,'Ylabel',text('String','Theta',...
   'HorizontalAlignment','center',...
   'VerticalAlignment','middle'))
hold on
polar(-uheltheta*pi/180,abs(Ezsek(uheltheta+1)),'r');
maxsek=max(abs(Ezsek));
set(findobj('Tag','sekundarni'),'String',['Ez_sekundrn_max = ' num2str(maxsek) ]);

subplot(1,2,2);
polar(uheltheta*pi/180,abs(Ezvysl(uheltheta+1)),'r');
set(gca,'Xlabel',text('String','Ez vsledn',...
   'HorizontalAlignment','center',...
   'VerticalAlignment','Top'))
set(gca,'Ylabel',text('String','Theta',...
   'HorizontalAlignment','center',...
   'VerticalAlignment','Top'))

hold on
polar(-uheltheta*pi/180,abs(Ezvysl(uheltheta+1)),'r');
maxvysl=max(abs(Ezvysl));
set(findobj('Tag','vysledna'),'String',['Ez_vsledn_max = ' num2str(maxvysl) ]);
set(findobj('Tag','vypis r a'),'String',strvcat(['r/lambda = ' num2str(r)],['a/lambda = ' num2str(a)]));


%doplnujici tlacitka ovladani KONEC a ZNOVU
h1 = uicontrol('Parent',h0, ...
	'Units','points', ...
    'BackgroundColor',[0.8 0.8 0.8], ...
    'Callback','zadanivaleccz', ...
	'ListboxTop',0, ...
	'Position',[3*wsize(3)/5+10 wsize(4)/15 37.5 15], ...
	'String','Znovu ', ...
	'Tag','Znovu');
h2 = uicontrol('Parent',h0, ...
	'Units','points', ...
    'BackgroundColor',[0.8 0.8 0.8], ...
    'Callback','close all', ...
	'ListboxTop',0, ...
    'Position',[3*wsize(3)/5+50 wsize(4)/15 37.5 15], ...
    'String','Konec ', ...
    'Tag','Konec');
h3 = uicontrol('Parent',h0, ...
	'Units','points', ...
    'BackgroundColor',[0.8 0.8 0.8], ...
    'Callback','vypocetrezycz', ...
	'ListboxTop',0, ...
    'Position',[3*wsize(3)/5+10 wsize(4)/15-20 77.5 15], ...
    'String','Pokrauj ezy ', ...
	'Tag','Pokracuj');

%smer sireni
h1 = uicontrol('Parent',h0, ...
	'BackgroundColor',[0.7 0.7 0.7], ...
   	'Callback','', ...
	'HorizontalAlignment','left', ...
	'ListboxTop',0, ...
	'Position',[410 50 210 20], ...
	'String',(' O <----- smr primrn vlny '), ...
    'FontSize',12,...
	'Style','text', ...
	'Tag','obr');

